DocIdSetIterator (Lucene 10.5.1 core API)
Description: declaration: package: org.apache.lucene.search, class: DocIdSetIterator

Package org.apache.lucene.search

# Class DocIdSetIterator

java.lang.Object
org.apache.lucene.search.DocIdSetIterator

Direct Known Subclasses:
  `AbstractDocIdSetIterator`, `BinaryDocValues`, `FilterDocIdSetIterator`, `KnnVectorValues.DocIndexIterator`, `NumericDocValues`, `PostingsEnum`, `SortedDocValues`, `SortedNumericDocValues`, `SortedSetDocValues`

public abstract class DocIdSetIterator extends Object
This abstract class defines methods to iterate over a set of non-decreasing doc ids. Note that this class assumes it iterates on doc Ids, and therefore `NO_MORE_DOCS` is set to 2147483647 in order to be used as a sentinel object. Implementations of this class are expected to consider `Integer.MAX_VALUE` as an invalid value.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `NO_MORE_DOCS`
  When returned by `nextDoc()`, `advance(int)` and `docID()` it means there are no more docs in the iterator.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DocIdSetIterator()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract int`
  `advance(int target)`
  Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself.
  `static DocIdSetIterator`
  `all(int maxDoc)`
  A `DocIdSetIterator` that matches all documents up to `maxDoc - 1`.
  `abstract long`
  `cost()`
  Returns the estimated cost of this `DocIdSetIterator`.
  `abstract int`
  `docID()`
  Returns the following: `-1` if `nextDoc()` or `advance(int)` were not called yet.
  `int`
  `docIDRunEnd()`
  Returns the end of the run of consecutive doc IDs that match this `DocIdSetIterator` and that contains the current `docID()`, that is: one plus the last doc ID of the run.
  `static DocIdSetIterator`
  `empty()`
  An empty `DocIdSetIterator` instance
  `void`
  `intoBitSet(int upTo, FixedBitSet bitSet, int offset)`
  Load doc IDs into a `FixedBitSet`.
  `abstract int`
  `nextDoc()`
  Advances to the next document in the set and returns the doc it is currently on, or `NO_MORE_DOCS` if there are no more docs in the set.
  NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
  `static DocIdSetIterator`
  `range(int minDoc, int maxDoc)`
  A `DocIdSetIterator` that matches a range documents from minDocID (inclusive) to maxDocID (exclusive).
  `protected final int`
  `slowAdvance(int target)`
  Slow (linear) implementation of `advance(int)` relying on `nextDoc()` to advance beyond the target position.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### NO_MORE_DOCS

    public static final int NO_MORE_DOCS
    When returned by `nextDoc()`, `advance(int)` and `docID()` it means there are no more docs in the iterator.
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### DocIdSetIterator

    public DocIdSetIterator()

- ## Method Details

  - ### empty

    public static DocIdSetIterator empty()
    An empty `DocIdSetIterator` instance

  - ### all

    public static DocIdSetIterator all(int maxDoc)
    A `DocIdSetIterator` that matches all documents up to `maxDoc - 1`.

  - ### range

    public static DocIdSetIterator range(int minDoc, int maxDoc)
    A `DocIdSetIterator` that matches a range documents from minDocID (inclusive) to maxDocID (exclusive).

  - ### docID

    public abstract int docID()
    Returns the following:
    - `-1` if `nextDoc()` or `advance(int)` were not called yet.
    - `NO_MORE_DOCS` if the iterator has exhausted.
    - Otherwise it should return the doc ID it is currently on.
    Since:
      2.9

  - ### nextDoc

    public abstract int nextDoc() throws IOException
    Advances to the next document in the set and returns the doc it is currently on, or `NO_MORE_DOCS` if there are no more docs in the set.
    NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
    Throws:
      `IOException`
    Since:
      2.9

  - ### advance

    public abstract int advance(int target) throws IOException
    Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself. Exhausts the iterator and returns `NO_MORE_DOCS` if target is greater than the highest document number in the set.

    The behavior of this method is undefined when called with `target ≤ current` , or after the iterator has exhausted. Both cases may result in unpredicted behavior.

    When `target > current` it behaves as if written:

         int advance(int target) {
           int doc;
           while ((doc = nextDoc()) < target) {
           }
           return doc;
         }

    Some implementations are considerably more efficient than that.

    NOTE: this method may be called with `NO_MORE_DOCS` for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

    Throws:
      `IOException`
    Since:
      2.9

  - ### slowAdvance

    protected final int slowAdvance(int target) throws IOException
    Slow (linear) implementation of `advance(int)` relying on `nextDoc()` to advance beyond the target position.
    Throws:
      `IOException`

  - ### cost

    public abstract long cost()
    Returns the estimated cost of this `DocIdSetIterator`.

    This is generally an upper bound of the number of documents this iterator might match, but may be a rough heuristic, hardcoded value, or otherwise completely inaccurate.

  - ### intoBitSet

    public void intoBitSet(int upTo, FixedBitSet bitSet, int offset) throws IOException
    Load doc IDs into a `FixedBitSet`. This should behave exactly as if implemented as below, which is the default implementation:

         for (int doc = docID(); doc < upTo; doc = nextDoc()) {
           bitSet.set(doc - offset);
         }

    Note: `offset` must be less than or equal to the `current doc ID`. Behaviour is undefined if this iterator is unpositioned.

    Note: It is important not to clear bits from `bitSet` that may be already set.

    Note: `offset` may be negative.

    Throws:
      `IOException`
    NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

  - ### docIDRunEnd

    public int docIDRunEnd() throws IOException
    Returns the end of the run of consecutive doc IDs that match this `DocIdSetIterator` and that contains the current `docID()`, that is: one plus the last doc ID of the run.
    1. The returned doc is greater than `docID()`.
    2. All docs in range `[docID(), docIDRunEnd())` match this iterator.
    3. The current position of this iterator is not affected by calling `docIDRunEnd()`.

    Note: It is illegal to call this method when the iterator is exhausted or not positioned.

    The default implementation assumes runs of a single doc ID and returns `docID()`) + 1.

    Throws:
      `IOException`